--- old/usr/src/cmd/ypcmd/revnetgroup/getgroup.c	Tue Sep 11 18:26:14 2012
+++ new/usr/src/cmd/ypcmd/revnetgroup/getgroup.c	Tue Sep 11 18:26:14 2012
@@ -23,10 +23,11 @@
 /*
  * Copyright (c) 1996, by Sun Microsystems, Inc.
  * All rights reserved.
+ *
+ * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
  */
-							    
-#ident	"%Z%%M%	%I%	%E% SMI"	/* SMI4.1 1.5 */
 
+#include <stdlib.h>
 #include <stdio.h>
 #include <ctype.h>
 #include <string.h>
@@ -34,8 +35,6 @@
 #include "util.h"
 #include "getgroup.h"
 
-#define	MAXGROUPLEN 1024
-
 /*
  * Stolen mostly, from getnetgrent.c
  *
@@ -53,57 +52,35 @@
 	struct list *nxt;
 };
 
-
-extern stringtable ngtable; /* stored info from /etc/netgroup */
-
-static struct grouplist *grouplist; /* stores a list of users in a group */
-
 static char *any();
 static char *match();
 static char *fill();
-static void freegrouplist();
-static void doit();
 
 
-
-static void
-freegrouplist()
+void
+freegrouplist(revhandle_t *hdl)
 {
-	struct grouplist *gl;
+	struct grouplist *gl, *next;
 
-	for (gl = grouplist; gl != NULL; gl = gl->gl_nxt) {
+	for (gl = hdl->grouplist; gl != NULL; gl = next) {
+		next = gl->gl_nxt;
+
 		FREE(gl->gl_name);
 		FREE(gl->gl_domain);
 		FREE(gl->gl_machine);
 		FREE(gl);
 	}
-	grouplist = NULL;
+	hdl->grouplist = NULL;
 }
 
 
 
-
-struct grouplist *
-my_getgroup(group)
-	char *group;
-{
-	freegrouplist();
-	doit(group, (struct list *) NULL);
-	return (grouplist);
-}
-
-
-
-
-
 /*
  * recursive function to find the members of netgroup "group". "list" is
  * the path followed through the netgroups so far, to check for cycles.
  */
-static void
-doit(group, list)
-	char *group;
-	struct list *list;
+void
+doit(char *group, struct list *list, revhandle_t *hdl)
 {
 	register char *p, *q;
 	register struct list *ls;
@@ -115,7 +92,7 @@
 	/*
 	 * check for non-existing groups
 	 */
-	if ((val = match(group)) == NULL) {
+	if ((val = match(group, hdl)) == NULL) {
 		return;
 	}
 
@@ -126,8 +103,8 @@
 	for (ls = list; ls != NULL; ls = ls->nxt) {
 		if (strcmp(ls->name, group) == 0) {
 			(void) fprintf(stderr,
-				"Cycle detected in /etc/netgroup: %s.\n",
-				group);
+			    "Cycle detected in /etc/netgroup: %s.\n",
+			    group);
 			return;
 		}
 	}
@@ -157,14 +134,14 @@
 			if (!(p = fill(p, &gpls->gl_domain, ')'))) {
 				goto syntax_error;
 			}
-			gpls->gl_nxt = grouplist;
-			grouplist = gpls;
+			gpls->gl_nxt = hdl->grouplist;
+			hdl->grouplist = gpls;
 		} else {
 			q = any(p, " \t\n#");
 			if (q && *q == '#')
 				break;
 			*q = EOS;
-			doit(p, list);
+			doit(p, list, hdl);
 			*q = ' ';
 		}
 		p = any(p, " \t");
@@ -242,8 +219,7 @@
  * The equivalent of yp_match. Returns the match, or NULL if there is none.
  */
 static char *
-match(group)
-	char *group;
+match(char *group, revhandle_t *hdl)
 {
-	return (lookup(ngtable, group));
+	return (lookup(hdl->ngtable, group));
 }
